unit Lexical;

interface

USES SysUtils;

TYPE TLexemeType=(LTrue, LFalse, LAnd, LOr, LNot, FINISH);

     Tres=RECORD
                      lexeme:TLExemeType;
                      value: LONGINT;
                      name:STRING;
                      position:WORD
                    END;
    TResult=ARRAY OF TRes;
    TLexicalAnalyzer=CLASS
     PRIVATE
      Ferr:STRING;
      Flex:TResult;
      FUNCTION GetError:STRING;
      FUNCTION GetLex:TResult;
      PUBLIC
      CONSTRUCTOR Create;
      DESTRUCTOR Free;
      PROCEDURE Run(s:STRING);
      PROPERTY Error:STRING READ GetError;
      PROPERTY Lexem:TResult READ GetLex;
      END;

implementation

DESTRUCTOR TLexicalAnalyzer.Free;

BEGIN
 Finalize(Flex)
END;

FUNCTION TLexicalAnalyzer.GetLex:TResult;

BEGIN
 Result:=Self.Flex
END;

CONSTRUCTOR TLexicalAnalyzer.Create;

BEGIN
 INHERITED Create;
 FErr:='';
 SetLength(FLex,0);
 END;

FUNCTION TLexicalAnalyzer.GetError:STRING;

BEGIN
 Result:=Ferr
END;

PROCEDURE TLexicalAnalyzer.Run(s:STRING);

VAR i:WORD;

PROCEDURE addlex(l:TLexemeType; v:LONGINT; n:STRING);

BEGIN
 SetLength(FLex,Length(FLex)+1);
 WITH FLex[Length(FLex)-1] DO
  BEGIN
   Lexeme:=L;
   Value:=v;
   Name:=n;
   Position:=i
  END
END;

PROCEDURE ReadAnd;

VAR n:STRING;

BEGIN
  n:=s[i];
  INC(i);
  If (i<=LENGTH(s)) AND (s[i] in ['n','N']) Then
      BEGIN
          n:=n+s[i];
          INC(i);
            If (i<=LENGTH(s)) AND (s[i] in ['d','D']) Then
                BEGIN
                    n:=n+s[i];
                    AddLex(LAnd,0,n);
                    {INC(i); }
                end
             ELSE {IF Not(s[i] in ['n','N']) THEN}  BEGIN Ferr:='    '''+s[i-1]+''''; Exit END;
      END
  ELSE {IF Not(s[i] in ['n','N']) THEN}  BEGIN Ferr:='   '''+s[i-1]+''''; Exit END;


 {DEC(i)}
END;

PROCEDURE ReadOr;

VAR n:STRING;

BEGIN
 n:=s[i];
 INC(i);
 If (i<=LENGTH(s)) AND (s[i] in ['r','R']) Then
  BEGIN
   n:=n+s[i];
   {INC(i); }
   AddLex(LOr,0,n);
  END
  ELSE IF Not(s[i] in ['r','R']) THEN  BEGIN Ferr:='   '''+s[i-1]+''''; Exit END;

 {DEC(i);}
 END;

PROCEDURE ReadNot;

VAR n:STRING;

BEGIN
 n:=s[i];
 INC(i);
 If (i<=LENGTH(s)) AND (s[i] in ['o','O'])Then
    BEGIN
        n:=n+s[i];
        INC(i);
        If (i<=LENGTH(s)) AND (s[i] in ['t','T']) Then
            BEGIN
                n:=n+s[i];
                  {INC(i);}
                AddLex(LNot,0,n);
            end
           Else  BEGIN Ferr:='   '''+s[i-1]+''''; Exit END;
     END

 ELSE {IF Not(s[i] in ['o','O']) THEN } BEGIN Ferr:='   '''+s[i-1]+''''; Exit END;


 {DEC(i);}
END;


BEGIN
 i:=1;
 SetLength(Flex,0);
 Ferr:='';
 WHILE i<=LENGTH(s) DO
  BEGIN
   CASE s[i] OF
    'T','t': AddLex(LTrue,0,'T');
    'F','f': AddLex(LFalse,0,'F');
    'A','a':  ReadAnd;
    'O','o': ReadOr;
    'N','n': ReadNot;

   ELSE
    BEGIN
     Ferr:=' ';
     Exit
    END
   END;
   INC(i)
  END;
 AddLex(FINISH,0,'')
END;

end.
