unit Syntax2;

interface

USES Lexical;

type TSyntaxAnalyzer=CLASS
     PROTECTED
      FLex:TResult;
      Ferr:STRING;
      Ferrpos:WORD;
      count:LONGINT;
      FUNCTION GetLex:TRes;
      FUNCTION GetError:STRING;
      FUNCTION GetErrorPos:WORD;
     PUBLIC
      CONSTRUCTOR Create(ll:TResult);
      DESTRUCTOR Free;
      PROPERTY error:STRING READ GetError;
      PROPERTY errorpos:WORD READ GetErrorPos;
      PROCEDURE Parse;VIRTUAL;
     END;

implementation

CONSTRUCTOR TSyntaxAnalyzer.Create(ll:TResult);

BEGIN
 INHERITED Create;
 Flex:=ll;
 count:=0;
 Ferr:='';
 Ferrpos:=0
END;

DESTRUCTOR TSyntaxAnalyzer.Free;

BEGIN
 Finalize(Flex)
END;


FUNCTION TSyntaxAnalyzer.GetError:STRING;

BEGIN
 Result:=self.Ferr
END;

FUNCTION TSyntaxAnalyzer.GetErrorPos:WORD;

BEGIN
 Result:=self.FErrPos
END;

FUNCTION TSyntaxAnalyzer.GetLex:TRes;

BEGIN
 IF count<=LENGTH(FLex)-1 THEN
  BEGIN
   Result:=Flex[count];
   INC(count)
  END
 ELSE
  WITH Result DO
   BEGIN
    Lexeme:=FINISH;
    name:='';
    value:=0;
    position:=0
   END
END;


PROCEDURE TSyntaxAnalyzer.Parse;

CONST unaryoper=LNot; // 
      binaryoper=[LAnd, LOr]; // 
      item=[LTrue,LFalse]; // 

TYPE TState=(TSTART, TITEM, TUNARYOPER, TBINARYOPER,TERROR, TFINISH);

VAR state:TState;
    curlex:TRes;

BEGIN
 state:=TSTART;
 REPEAT
   curlex:=GetLex;
   CASE state OF
   TSTART:
    IF curlex.lexeme = unaryoper THEN
     State:=TUNARYOPER
    ELSE
     IF curlex.lexeme IN item THEN
      State:=TITEM
     {ELSE
     IF curlex.lexeme = FINISH THEN
      State:=TFINISH }
      Else
      State:=TERROR;
   TITEM:
    IF curlex.Lexeme IN  binaryoper THEN
     state:=TBINARYOPER
    ELSE
    {IF curlex.Lexeme =  unaryoper THEN
     state:=TUNARYOPER
      ELSE}
     IF curlex.lexeme = FINISH THEN
      State:=TFINISH
       ELSE
     state:=TERROR;
   TUNARYOPER:
    IF curlex.Lexeme IN item THEN
     state:=TITEM
    ELSE
     state:=TERROR;
   TBINARYOPER:
   IF curlex.Lexeme IN item THEN
     state:=TITEM
    ELSE
     state:=TERROR;

    END;
   UNTIL  (State=TERROR) OR (curlex.lexeme=FINISH);

// IF (curlex.lexeme<>FINISH) THEN
 IF STATE=TERROR THEN
  BEGIN
   Ferr:=' ';
   FErrPos:=curlex.position
  END
END;
end.

